Index: /branches/rsr.v5.1.dev/web/app/data/modules/data_config.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/data/modules/data_config.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/data/modules/data_config.php	(revision 1)
@@ -0,0 +1,59 @@
+<?php
+
+  class data_config extends data
+  {
+
+    function config($key = null)
+    { $value = false;
+      try
+      {
+        if(isset($key))
+        { $sql = "SELECT `value` FROM #--configuration WHERE `key`=".$this->eq($key);
+          $rst = $this->sql->query($sql);
+          if($v_rst = $this->sql->fetch_assoc($rst)) $value = $v_rst["value"];
+          else $value = "";
+          $this->sql->free_result($rst);
+        }
+        else
+        { $value = array();
+          $sql = "SELECT * FROM #--configuration";
+          $rst = $this->sql->query($sql);
+          while($v_rst = $this->sql->fetch_assoc($rst)) $value[$v_rst["key"]] = $v_rst["value"];
+          $this->sql->free_result($rst);
+        }
+      }
+      catch(Exception $_e) { $value = false; }
+      return $value;
+    }
+
+    function config_exists($key)
+    { $exists = false;
+      try
+      { $sql = "SELECT count(*) as n FROM #--configuration WHERE `key`=".$this->eq($key);
+        $rst = $this->sql->query($sql);
+        if($v_rst = $this->sql->fetch_assoc($rst)) $exists = $v_rst["n"];
+        $this->sql->free_result($rst);
+      }
+      catch(Exception $_e) {}
+      return $exists;
+    }
+
+    function set_config($key, $value)
+    { try
+      { if($this->config_exists($key)) $sql =
+         "UPDATE #--configuration"
+        ." SET `value`=".$this->eq($value)
+        ." WHERE `key`=".$this->eq($key);
+        else $sql =
+         "INSERT INTO #--configuration"
+        ." VALUES(".$this->eq($key).", ".$this->eq($value).")";
+        $this->sql->query($sql);
+        return true;
+      }
+      catch(Exception $_e) {}
+      return false;
+    }
+
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/data/modules/data_forum.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/data/modules/data_forum.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/data/modules/data_forum.php	(revision 1)
@@ -0,0 +1,58 @@
+<?php
+
+  class data_forum extends data
+  {
+    function forums()
+    { $forums = array();
+      try
+      { $sql = "SELECT * FROM #--pun_forums";
+        $rst = $this->sql->query($sql);
+        while($v_rst = $this->sql->fetch_assoc($rst)) $forums[$v_rst["id"]] = $v_rst;
+      }
+      catch(Exception $_e) { $forums = false; }
+      return $forums;
+    }
+
+    function forum_last_messages($max, $id_forum = null)
+    { $messages = array();
+      try
+      { $query =
+         "SELECT p.id as post_id, p.posted, t.id as topic_id, t.subject, f.forum_name"
+        ." FROM #--pun_posts p, #--pun_topics t, #--pun_forums f"
+        ." WHERE p.topic_id=t.id"
+        ." AND t.forum_id=f.id"
+        .(isset($id_forum) ? " AND f.id=".$id_forum : "")
+        ." ORDER BY p.posted DESC"
+        ." LIMIT 0,".$max;
+        $rst = $this->sql->query($query);
+        while($v_rst = $this->sql->fetch_assoc($rst)) $messages[$v_rst["post_id"]] = $v_rst;
+      }
+      catch(Exception $_e) { $messages = false; }
+      return $messages;
+    }
+
+    function nous_y_etions()
+    {
+      // adapter ici avec l'identifiant du forum
+      $forum_id = 84;
+
+      $post = array();
+      try
+      { $query =
+         "SELECT p.id as post_id, p.posted, t.id as topic_id, t.subject, f.forum_name"
+        ." FROM #--pun_posts p, #--pun_topics t, #--pun_forums f"
+        ." WHERE p.topic_id=t.id"
+        ." AND t.forum_id=f.id"
+        ." AND f.id=".$forum_id
+        ." ORDER BY RAND()"
+        ." LIMIT 0,1";
+        $rst = $this->sql->query($query);
+        if($v_rst = $this->sql->fetch_assoc($rst)) $post = $v_rst;
+      }
+      catch(Exception $_e) { $post = false; }
+      return $post;
+    }
+
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/data/modules/data_images.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/data/modules/data_images.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/data/modules/data_images.php	(revision 1)
@@ -0,0 +1,193 @@
+<?php
+
+  class data_images extends data
+  {
+    public $image_error = "";
+    public $image_message = "";
+
+    function get_image_error() { return $this->image_error; }
+    function get_image_message() { return $this->image_message; }
+
+    function img_size($file, $max_width, $max_height)
+    { $img_infos = getimagesize($file);
+      if($img_infos)
+      { if($img_infos[0] > $max_width || $img_infos[1] > $max_height)
+        { $r = $max_width / $img_infos[0];
+          if($r * $img_infos[1] > $max_height) $r = $max_height / $img_infos[1];
+          $img_size = array
+          ( "width" => floor($r * $img_infos[0]),
+            "height" => floor($r * $img_infos[1]) 
+          );
+        }
+        else $img_size = array
+        ( "width" => $img_infos[0],
+          "height" => $img_infos[1] 
+        );
+        return $img_size;
+      }
+      return false;
+    }
+
+    function unique_file_name($dest, $file_name, $prefix = "img_")
+    { $dest .= strlen($dest) > 0 && substr($dest, -1) != "/" ? "/" : "";
+      if(is_dir($dest))
+      { $ext = "";
+        if(strpos($file_name, ".") !== false)
+        { $v_ext_path = explode(".", $file_name);
+          $ext = ".".$v_ext_path[count($v_ext_path) - 1];
+        }
+        $i = 0;
+        while(file_exists($dest.$prefix.$i.$ext)) $i++;
+        return $prefix.$i.$ext;
+      }
+      return false;
+    }
+
+    function upload_image($image, $dest, $img_file = null)
+    { switch($_FILES[$image]["error"])
+      { case UPLOAD_ERR_OK : break;
+        default : $this->image_error = "Impossible d'uploader l'image.";
+      }
+      if(!$this->image_error)
+      { $img_file = isset($img_file) ? $img_file : $_FILES[$image]["name"];
+        $v_name = explode(".", $img_file);
+        $ext = $v_name[count($v_name) - 1];
+        if
+        ( strcasecmp($ext, "png") == 0 ||
+          strcasecmp($ext, "gif") == 0 ||
+          strcasecmp($ext, "jpg") == 0 ||
+          strcasecmp($ext, "jpeg") == 0
+        )
+        { if(file_exists($dest))
+          { if(!is_dir($dest)) $this->image_error = "le dossier d'upload est un fichier. Impossible d'y uploader l'image";
+          }
+          else
+          { @mkdir($dest);
+            clearstatcache();
+            if(!file_exists($dest) && !is_dir($dest)) $this->image_error = "Impossible de creer le dossier d'upload";
+          }
+          if(!$this->image_error)
+          { if
+            ( @move_uploaded_file
+              ( $_FILES[$image]["tmp_name"],
+                $dest."/".$img_file
+              ) !== false
+            ) return $img_file;
+            else $this->image_error = "Impossible de copier l'image uploadee";
+          }
+        }
+        else $this->image_message = "Le fichier image doit &ecirc;tre au format png, gif ou jpg";
+      }
+      return false;
+    }
+
+    function img_thumb($src, $max_width, $max_height, $thumbs_dir = "")
+    { if(strlen($thumbs_dir) > 0)
+      { if(!@is_dir($thumbs_dir)) @mkdir($thumbs_dir);
+        if(!@is_dir($thumbs_dir)) return false;
+      }
+      $thumb = array();
+      try
+      { $sql =
+         "SELECT *"
+        ." FROM #--thumbs"
+        ." WHERE src=".$this->eq($src)
+        ." AND max_width=".$this->eq($max_width)
+        ." AND max_height=".$this->eq($max_height);
+        $rst = $this->sql->query($sql);
+        if($v_rst = $this->sql->fetch_assoc($rst)) $thumb = $v_rst;
+        $this->sql->free_result($rst);
+      }
+      catch(Exception $_e) { $thumb = false; }
+      if($thumb !== false)
+      { if($thumb) return $thumb;
+        $thumbs_dir .= strlen($thumbs_dir) > 0 && substr($thumbs_dir, -1) != "/" ? "/" : "";
+        $thumb_dir = $max_width."x".$max_height."/";
+        if(!@is_dir($thumbs_dir.$thumb_dir)) @mkdir($thumbs_dir.$thumb_dir);
+        if(!@is_dir($thumbs_dir.$thumb_dir)) return false;
+        $thumb_file = $thumb_dir.$this->unique_file_name($thumbs_dir.$thumb_dir, $src, "img_");
+        if($thumb_file === false) return false;
+        if(($thumb = $this->make_thumb($src, $max_width, $max_height, $thumbs_dir, $thumb_file)) !== false)
+        { try
+          { $sql =
+             "INSERT INTO #--thumbs"
+            ."(src, src_width, src_height, max_width, max_height, thumb_file, thumb_width, thumb_height, creation_date) VALUES"
+            ."( ".$this->eq($thumb["src"])
+            .", ".$this->eq($thumb["src_width"])
+            .", ".$this->eq($thumb["src_height"])
+            .", ".$this->eq($max_width)
+            .", ".$this->eq($max_height)
+            .", ".$this->eq($thumb["thumb_file"])
+            .", ".$this->eq($thumb["thumb_width"])
+            .", ".$this->eq($thumb["thumb_height"])
+            .", ".$this->eq($thumb["creation_date"])
+            .")";
+            $rst = $this->sql->query($sql);
+            return $thumb;
+          }
+          catch(Exception $_e) {}
+        }
+      }
+      return false;
+    }
+
+    function make_thumb($src, $max_width, $max_height, $thumbs_dir, $thumb_file, $quality = null)
+    { $dest = $thumbs_dir.$thumb_file;
+      $size = getimagesize($src);
+      if($size[0])
+      { if($size[0] > $size[1])
+        { $width = $max_width;
+          $height = ($size[1] * ($width / $size[0]));
+        }
+        else
+        { $height = $max_height;
+          $width = $size[0] * ($height / $size[1]);
+        }
+        $v_ext_path = explode(".", $src);
+        $ext = $v_ext_path[count($v_ext_path) - 1];
+        if(strcasecmp($ext, "jpg") == 0 || strcasecmp($ext, "jpeg") == 0)  $ext = "jpg";
+        elseif(strcasecmp($ext, "gif") == 0)  $ext = "gif";
+        elseif(strcasecmp($ext, "png") == 0)  $ext = "png";
+        else $ext = "";
+        $create_function = "";
+        $thumb_function = "";
+        if(strcasecmp($ext, "jpg") == 0)
+        { $create_function = "imagecreatefromjpeg";
+          $thumb_function = "imagejpeg";
+        }
+        elseif(strcasecmp($ext, "gif") == 0)
+        { $create_function = "imagecreatefromgif";
+          $thumb_function = "imagegif";
+          $quality = NULL;
+        }
+        elseif(strcasecmp($ext, "png") == 0)
+        { $create_function = "imagecreatefrompng";
+          $thumb_function = "imagepng";
+        }
+        if($create_function)
+        { $src_img = $create_function($src);
+          $thumb_img = imagecreatetruecolor($width, $height);
+          imagecopyresampled($thumb_img, $src_img, 0, 0, 0, 0, $width, $height, $size[0], $size[1]);
+          if(isset($quality)) $thumb_img = $thumb_function($thumb_img, $dest, $quality);
+          else $thumb_img = $thumb_function($thumb_img, $dest);
+          if($thumb_img !== false)
+          { return array
+            ( "src" => $src,
+              "src_width" => $size[0],
+              "src_height" => $size[1],
+              "max_width" => $max_width,
+              "max_height" => $max_height,
+              "thumb_file" => $thumb_file,
+              "thumb_width" => $width,
+              "thumb_height" => $height,
+              "creation_date" => date("Y-m-d H:i:s")
+            );
+          }
+        }
+      }
+      return false;
+    }
+
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/data/modules/data_map.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/data/modules/data_map.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/data/modules/data_map.php	(revision 1)
@@ -0,0 +1,205 @@
+<?php
+
+  class data_map extends data
+  {
+
+    function map_emplacements()
+    { $emplacements = false;
+      try
+      { $query =
+         "SELECT * FROM #--map_emplacement";
+        $rst = $this->sql->query($query);
+        $emplacements = array();
+        while($v_rst = $this->sql->fetch_assoc($rst))
+        { $emplacements[$v_rst["id"]] = $v_rst;
+          $emplacements[$v_rst["id"]]["editable"] = $this->edit_emplacement_ok($emplacements[$v_rst["id"]]);
+        }
+        $this->sql->free_result($rst);
+      }
+      catch(Exception $_e) { $emplacements = false; }
+      return $emplacements;
+    }
+
+    function map_emplacement($id)
+    { $emplacement = false;
+      try
+      { $query =
+         "SELECT * FROM #--map_emplacement WHERE id=".$id;
+        $rst = $this->sql->query($query);
+        if($v_rst = $this->sql->fetch_assoc($rst)) $emplacement = $v_rst;
+        $this->sql->free_result($rst);
+      }
+      catch(Exception $_e) { $emplacement = false; }
+      return $emplacement;
+    }
+
+    function map_emplacement_types()
+    { $emplacement_types = false;
+      try
+      { $query =
+         "SELECT * FROM #--map_emplacement_type";
+        $rst = $this->sql->query($query);
+        $emplacement_types = array();
+        while($v_rst = $this->sql->fetch_assoc($rst)) $emplacement_types[$v_rst["id"]] = $v_rst;
+        $this->sql->free_result($rst);
+      }
+      catch(Exception $_e) { $emplacement_types = false; }
+      return $emplacement_types;
+    }
+
+    function map_emplacement_type($id)
+    { $emplacement_type = false;
+      try
+      { $query =
+         "SELECT * FROM #--map_emplacement_type"
+        ." WHERE id=".$this->eq($id);
+        $rst = $this->sql->query($query);
+        if($v_rst = $this->sql->fetch_assoc($rst)) $emplacement_type = $v_rst;
+        $this->sql->free_result($rst);
+      }
+      catch(Exception $_e) { $emplacement_type = false; }
+      return $emplacement_type;
+    }
+
+    function add_map_emplacement_type($intitule, $descriptif, $icone)
+    { try
+      { $query =
+         "INSERT INTO #--map_emplacement_type(intitule, descriptif, icone) VALUES"
+        ."( ".$this->eq($intitule)
+        .", ".$this->eq($descriptif)
+        .", ".$this->eq($icone)
+        .")";
+        $this->sql->query($query);
+      }
+      catch(Exception $_e) { return false; }
+      return true;
+    }
+
+    function set_map_emplacement_type($id, $intitule, $descriptif, $icone = null)
+    { try
+      { $query =
+         "UPDATE #--map_emplacement_type SET"
+        ."  intitule=".$this->eq($intitule)
+        .", descriptif=".$this->eq($descriptif)
+        .(isset($icone) ? ", icone=".$this->eq($icone) : "")
+        ." WHERE id=".$this->eq($id);
+        $this->sql->query($query);
+      }
+      catch(Exception $_e) { return false; }
+      return true;
+    }
+
+    function del_map_emplacement_type($id)
+    { if(($emplacement_type = $this->map_emplacement_type($id)) !== false)
+      { try
+        { $query =
+           "DELETE FROM #--map_emplacement WHERE map_emplacement_type=".$this->eq($id);
+          $this->sql->query($query);
+          $query =
+           "DELETE FROM #--map_emplacement_type WHERE id=".$this->eq($id);
+          $this->sql->query($query);
+          $this->del_map_emplacement_type_icone($emplacement_type["icone"]);
+        }
+        catch(Exception $_e) { return false; }
+        return true;
+      }
+      return false;
+    }
+
+    function del_map_emplacement_type_icone($icone)
+    { try
+      { $delete_icone = false;
+        if($icone && file_exists($icone))
+        { try
+          { $query =
+             "SELECT count(*) as n"
+            ." FROM #--map_emplacement_type"
+            ." WHERE icone=".$this->eq($icone);
+            $rst = $this->sql->query($query);
+            if($v_rst = $this->sql->fetch_assoc($rst)) $delete_icone = $v_rst["n"] == 1;
+            $this->sql->free_result($rst);
+          }
+          catch(Exception $_e) { return false; }
+        }
+        if($delete_icone) @unlink($icone);
+        return true;
+      }
+      catch(Exception $_e) {}
+      return false;
+    }
+
+    function add_map_emplacement($latitude, $longitude, $map_emplacement_type, $info, $user)
+    { if($this->edit_map_ok())
+      { try
+        { $query =
+           "INSERT INTO #--map_emplacement VALUES"
+          ."(NULL"
+          .", ".$latitude
+          .", ".$longitude
+          .", ".$map_emplacement_type
+          .", ".$this->eq($info)
+          .", NOW()"
+          .", ".$user
+          .", NOW()"
+          .", ".$user
+          .")";
+          $this->sql->query($query);
+          return $this->sql->insert_id();
+        }
+        catch(Exception $_e) {}
+      }
+      return false;
+    }
+
+    function set_map_emplacement($id, $latitude, $longitude, $map_emplacement_type, $info, $user)
+    { if(($empl = $this->map_emplacement($id)) !== false)
+      { if($this->edit_emplacement_ok($empl))
+        { try
+          { $query =
+             "UPDATE #--map_emplacement SET"
+            ."  latitude=".$latitude
+            .", longitude=".$longitude
+            .", map_emplacement_type=".$map_emplacement_type
+            .", info=".$this->eq($info)
+            .", modification_date=NOW()"
+            .", modification_user=".$user
+            ." WHERE id=".$id;
+            $this->sql->query($query);
+            return true;
+          }
+          catch(Exception $_e) {}
+        }
+      }
+      return false;
+    }
+
+    function del_map_emplacement($id)
+    { if(($empl = $this->map_emplacement($id)) !== false)
+      { if($this->edit_emplacement_ok($empl))
+        { try
+          { $query =
+             "DELETE FROM #--map_emplacement WHERE id=".$id;
+            $this->sql->query($query);
+            return true;
+          }
+          catch(Exception $_e) {}
+        }
+      }
+      return false;
+    }
+
+    function view_map_ok()
+    { return !$this->env->pun_user["is_guest"];
+    }
+
+    function edit_map_ok()
+    { return $this->view_map_ok();
+    }
+
+    function edit_emplacement_ok($empl)
+    { return $this->env->pun_user["group_id"] == 1 || ($this->edit_map_ok() && $this->env->pun_user["id"] == $empl["creation_user"]);
+    }
+
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/data/modules/data_playlists.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/data/modules/data_playlists.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/data/modules/data_playlists.php	(revision 1)
@@ -0,0 +1,91 @@
+<?php
+
+  class data_playlists extends data
+  {
+
+    function pl_last_downloads($n = null)
+    { return $this->dp_playlist
+      ( " ORDER BY #--download_urls.date_publication DESC"
+       .(isset($n) ? " LIMIT ".$n : "")
+      );
+    }
+
+    function pl_rand_downloads($n = null)
+    { return $this->dp_playlist
+      ( " ORDER BY RAND()"
+       .(isset($n) ? " LIMIT ".$n : "")
+      );
+    }
+
+    function pl_artiste_downloads($id_artiste, $album = null)
+    { return $this->dp_playlist
+      (  (isset($album) ? " AND #--downloads.id_album=".$album : "")
+        ." AND #--artistes.id=".$id_artiste
+        ." ORDER BY #--downloads.ordre ASC"
+       .(isset($n) ? " LIMIT ".$n : "")
+      );
+    }
+
+    function dp_playlist($_sql)
+    { $playlist = array();
+      try
+      { $sql =
+         "SELECT *"
+        .", YEAR(date_updated) as year_updated"
+        .", IF(MONTH(date_updated) > 9, MONTH(date_updated), CONCAT('0', MONTH(date_updated))) as month_updated"
+        .", IF(DAYOFMONTH(date_updated) > 9, DAYOFMONTH(date_updated), CONCAT('0', DAYOFMONTH(date_updated))) as day_updated"
+        ." FROM ( SELECT"
+        ."  distinct(#--download_urls.id_download)"
+        .", #--download_urls.id as id_download_url"
+        .", #--download_urls.url"
+        .", #--downloads.nom as titre"
+        .", #--downloads.style"
+        .", #--formats.content_type"
+        .", #--artistes.nom as auteur"
+        .", #--artistes.id as id_auteur"
+        .", #--licences.id as id_licence"
+        .", #--licences.nom as licence"
+        .", #--licences.lien as licence_url"
+        .", #--downloads.date_creation as date_created"
+        .", #--download_urls.date_publication as date_updated"
+        ." FROM"
+        ."  #--download_urls"
+        .", #--formats"
+        .", #--downloads"
+        .", #--artistes"
+        .", #--licences"
+        ." WHERE #--download_urls.id_format=#--formats.id"
+        ." AND #--download_urls.id_download=#--downloads.id"
+        ." AND #--downloads.id_artiste=#--artistes.id"
+        ." AND #--downloads.id_licence=#--licences.id"
+        ." AND actif=1"
+        .$_sql
+        .") t";
+        $rst = $this->sql->query($sql);
+        while($v_rst = $this->sql->fetch_assoc($rst))
+        { $playlist[$v_rst["id_download"]] = $v_rst;
+          $playlist[$v_rst["id_download"]]["urls"] = array();
+          $u_query =
+           "SELECT #--download_urls.*, #--formats.nom as format"
+          ." FROM #--download_urls, #--formats"
+          ." WHERE id_download=".$v_rst["id_download"]
+          ." AND #--download_urls.id_format=#--formats.id";
+          $u_rst = $this->sql->query($u_query);
+          while($v_u_rst = $this->sql->fetch_assoc($u_rst))
+          { $playlist[$v_rst["id_download"]]["urls"][$v_u_rst["id"]] = $v_u_rst;
+            $playlist[$v_rst["id_download"]]["compteur"] += $v_u_rst["compteur"];
+            if($v_u_rst["format"] === "mp3")
+            { $playlist[$v_rst["id_download"]]["mp3_id_url"] = $v_u_rst["id"];
+              $playlist[$v_rst["id_download"]]["mp3_url"] = $v_u_rst["url"];
+            }
+          }
+          $this->sql->free_result($u_rst);
+        }
+      }
+      catch(Exception $_e) { $playlist = false; }
+      return $playlist;
+    }
+
+  }
+
+?>
Index: /branches/rsr.v5.1.dev/web/app/data/modules/data_search.php
===================================================================
--- /branches/rsr.v5.1.dev/web/app/data/modules/data_search.php	(revision 1)
+++ /branches/rsr.v5.1.dev/web/app/data/modules/data_search.php	(revision 1)
@@ -0,0 +1,74 @@
+<?php
+
+  class data_search extends data
+  {
+
+    function search($match)
+    { $results = array
+      ( "has_results" => false,
+        "match" => $match,
+        "artistes" => array(),
+        "downloads" => array(),
+        "albums" => array()
+      );
+      try
+      { if($match)
+        { $sql =
+           "SELECT id, nom, style, image"
+          ." FROM #--artistes"
+          ." WHERE nom LIKE ".$this->eq("%".$match."%")
+          ." OR style LIKE ".$this->eq("%".$match."%");
+          $rst = $this->sql->query($sql);
+          while($v_rst = $this->sql->fetch_assoc($rst)) $results["artistes"][$v_rst["id"]] = $v_rst;
+          $this->sql->free_result($rst);
+
+          $sql =
+           "SELECT #--downloads.*"
+          .", #--downloads.id as id_download"
+          .", #--downloads.nom as titre"
+          .", #--downloads.date_creation as date_created"
+          .", #--artistes.id as id_artiste"
+          .", #--artistes.nom as auteur"
+          .", #--licences.nom as licence"
+          .", #--licences.lien as licence_url"
+          ." FROM #--artistes"
+          .", #--downloads"
+          .", #--licences"
+          ." WHERE #--downloads.id_artiste=#--artistes.id"
+          ." AND #--downloads.id_licence=#--licences.id"
+          ." AND actif=1"
+          ." AND #--downloads.nom LIKE ".$this->eq("%".$match."%");
+          $rst = $this->sql->query($sql);
+          while($v_rst = $this->sql->fetch_assoc($rst))
+          { $results["downloads"][$v_rst["id"]] = $v_rst;
+            $results["downloads"][$v_rst["id"]]["urls"] = array();
+            $u_sql =
+             "SELECT #--download_urls.*, #--formats.nom as format"
+            ." FROM #--download_urls, #--formats"
+            ." WHERE id_download=".$v_rst["id"]
+            ." AND #--download_urls.id_format=#--formats.id";
+            $u_rst = $this->sql->query($u_sql);
+            while($v_u_rst = $this->sql->fetch_assoc($u_rst))
+            { $results["downloads"][$v_rst["id"]]["urls"][$v_u_rst["id"]] = $v_u_rst;
+              if($v_u_rst["format"] === "mp3")
+              { $results["downloads"][$v_rst["id"]]["mp3_id_url"] = $v_u_rst["id"];
+                $results["downloads"][$v_rst["id"]]["mp3_url"] = $v_u_rst["url"];
+              }
+            }
+            $this->sql->free_result($u_rst);
+          }
+          $this->sql->free_result($rst);
+
+          $results["has_results"] =
+             $results["artistes"]
+          || $results["downloads"]
+          || $results["albums"];
+        }
+      }
+      catch(Exception $_e) { $results = false; }
+      return $results;
+    }
+
+  }
+
+?>
